# Adelie

[Adelie](https://100r.co/site/adelie.html) is a slideshow program, written in [Uxntal](https://wiki.xxiivv.com/site/uxntal.html).

## Build

You must have the [Uxn](https://git.sr.ht/~rabbits/uxn) assembler and emulator.

```sh
uxnasm src/adelie.tal bin/adelie.rom
uxnemu bin/adelie.rom slides.txt
```

If do not wish to assemble it yourself, you can download [adelie.rom](https://rabbits.srht.site/adelie/adelie.rom).

[![builds.sr.ht status](https://builds.sr.ht/~rabbits/adelie.svg)](https://builds.sr.ht/~rabbits/adelie?)

## Slide Format

Every parameter besides `text` and `id`, is a lowercase hexadecimal byte value. The slides are stored as plain-text in the following format:

- `SIZE w,h`, set size
- `NAME text`, slide id
- `WAIT`, automate slide controls
- `STOP`, ignore slide controls
- `LINK w,h id`, rectangle link to slide

### Drawing

- `MODE color`, set colormode
- `GOTO x,y`, move to absolute position
- `MOVE x,y`, move by relative position
- `PICT name.tga`, draw picture
- `HEAD text`, draw header
- `TEXT text`, draw text
- `FILL color`, fill background
- `RECT w,h color`, fill rect

## Example

```
SIZE 30,1c ( 768 x 448 )

NAME Slide 1
FILL 00
GOTO 04,04
PICT photo.tga
GOTO 03,24
MODE 05
HEAD Header A
MOVE 00,05
TEXT Some text with a linebreak,`and a second line.

NAME Slide 2
FILL 01
MODE 07
RECT 10,50 0a
GOTO 20,20
MODE 03
LINK 10,02 Slide 1
TEXT Return to first slide
STOP
```

## Patterns

You can change the fill pattern using the `PATT` operation, the expected values are equal to an [ICN tile](http://wiki.xxiivv.com/site/icn_format.html).

- `PATT c3 81 18 3c 3c 18 81 c3`

## Controls

### Mouse

- `mouse1` next slide
- `mouse2` draw marker
- `mouse3` prev slide

### Arrows

- `left` prev slide
- `right` next slide

### Keys

- `alt`, prev slide
- `ctrl`, next slide
- `shift`, toggle link view

## Misc

To make a monochrome tga file:

```
convert -colorspace Gray -resize 704x448 -extent 704x448 -gravity center -background black picture.jpg picture.tga
```

## Support

- [theme](https://wiki.xxiivv.com/site/theme.html)
